<template>
    <div>
        <!-- <pre>
            {{ $v.formReg.email }}
        </pre> -->
        <main class="main">
            <section class="registration">
                <div class="registration__group">
                    <h2 class="registration__title h2">Зарегистрировать аккаунт</h2>
                </div>
                <form @submit.prevent="registerUser" class="form" novalidate>
                    <div class="form__group">
                        <p class="red--text" v-if="$v.formReg.login.minLength === false">Минимальная длина логина 2 символа</p>
                        <label class="form__label" for="login">Login<span class="reqiured">*</span></label>
                        <input
                        @blur="$v.formReg.login.$touch()"
                        :class="{'is-invalid': $v.formReg.login.$error}"
                         v-model.trim="formReg.login" 
                         class="form__input" 
                         type="text" 
                         id="login">
                    </div>
                    <div class="form__group">
                        <label class="form__label" for="email">Email<span class="reqiured">*</span></label>
                        <input @blur="$v.formReg.email.$touch()"
                         :class="{'is-invalid': $v.formReg.email.$error}" 
                         v-model.trim="formReg.email" 
                         class="form__input" 
                         type="text" 
                         id="email">
                    </div>
                    <div class="form__group">
                        <p class="red--text" v-if="$v.formReg.password.minLength === false">Минимальная длина пароля 6 символов</p>
                        <label class="form__label" for="password">Password<span class="reqiured">*</span></label>
                        <input @blur="$v.formReg.password.$touch()"
                        :class="{'is-invalid': $v.formReg.password.$error}" 
                        v-model.trim="formReg.password" 
                        class="form__input" 
                        type="password" 
                        id="password">
                    </div>
                    <div class="form__group form__group-center">
                        <button class="form__button" type="submit">Зарегестрироваться</button>
                    </div>
                </form>
            </section>
        </main>
    </div>
</template>

<script>

import { required, minLength, email } from 'vuelidate/lib/validators'

export default {
    data() {
        return {
            formReg: {
                login: "",
                email: "",
                password: ""
            }
        }
    },
    methods: {
        registerUser() {
            const person = {
                login: this.formReg.login,
                email: this.formReg.email,
                passsword: this.formReg.password
            }
            const personFormat = JSON.stringify(person)
            if (this.formReg.login.length < 2 || this.formReg.password.length < 6 || this.$v.formReg.email.email === false) {
                alert("Введите данные правильно!")
            } else {
            localStorage.setItem(`${this.formReg.login}`, personFormat)
            this.$router.push({name: 'login'})
            }
        }
    },
    validations: {
        formReg: {
            login: {
                required,
                minLength: minLength(2)
            },
            email: {
                required,
                email,
            },
            password: {
                required,
                minLength: minLength(6)
            }
        }
    }
}
</script>

<style>
.reqiured{
    color: red;
}

.red--text{
    font-size: 0.8rem;
}

.registration{
    display: flex;
    flex-direction: column;
    max-width: 500px;
    margin: 0 auto;
    margin-top: 35px;
}

.form__group{
    display: flex;
    flex-direction: column;
    margin-top: 35px;
}

.form__group-center{
    justify-content: center;
}

.form__input{
    margin-top: 5px;
    border: black 1px solid;
    border-radius: 8px;
    padding: 4px 7px;
}

.is-invalid{
    border:red 2px solid;
}

.h2{
    font-size: 1.5rem;
}

.registration__group{
    display: flex;
    justify-content: center;
}

.form__button{
    background-color:#081935;
    color: white;
    padding: 8px 4px;
}

@media screen and (max-width: 550px) {
    .h2{
        font-size: 1.2rem;
    }
    .form__label{
        font-size: 0.8rem;
    }
}

</style>